from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String, Float, Int

Unitig_Caller_V0_1_0 = CommandToolBuilder(tool="unitig_caller", base_command=["unitig-caller"], inputs=[ToolInput(tag="in_build", input_type=Boolean(optional=True), prefix="--build", doc=InputDocumentation(doc="Build coloured/uncoloured de Bruijn graph using")), ToolInput(tag="in_simple", input_type=Boolean(optional=True), prefix="--simple", doc=InputDocumentation(doc="Use FM-index to make calls")), ToolInput(tag="in_refs", input_type=File(optional=True), prefix="--refs", doc=InputDocumentation(doc="Ref file to use to --build bifrost graph (or with")), ToolInput(tag="in_reads", input_type=File(optional=True), prefix="--reads", doc=InputDocumentation(doc="Read file to use to --build bifrost graph")), ToolInput(tag="in_graph_prefix", input_type=String(optional=True), prefix="--graph-prefix", doc=InputDocumentation(doc="Prefix of bifrost graph to --query")), ToolInput(tag="in_unit_igs", input_type=File(optional=True), prefix="--unitigs", doc=InputDocumentation(doc="fasta file of unitigs to query (--query or --simple)")), ToolInput(tag="in_output", input_type=String(optional=True), prefix="--output", doc=InputDocumentation(doc="Prefix for output [default = 'unitig_caller']")), ToolInput(tag="in_no_colour", input_type=Boolean(optional=True), prefix="--no_colour", doc=InputDocumentation(doc="Specify for uncoloured de Bruijn Graph [default =\nFalse]")), ToolInput(tag="in_clean", input_type=Boolean(optional=True), prefix="--clean", doc=InputDocumentation(doc="Clean DBG (clip tips and delete isolated contigs\nshorter than k k-mers in length) [default = False]")), ToolInput(tag="in_ratio_k", input_type=Float(optional=True), prefix="--ratiok", doc=InputDocumentation(doc="ratio of k-mers from queries that must occur in the\ngraph to be considered as belonging to colour [default\n= 1.0]")), ToolInput(tag="in_in_exact", input_type=Boolean(optional=True), prefix="--inexact", doc=InputDocumentation(doc="Graph is searched with exact and inexact k-mers (1\nsubstitution or indel) from queries [default = False]")), ToolInput(tag="in_km_er_size", input_type=Int(optional=True), prefix="--kmer_size", doc=InputDocumentation(doc="K-mer size for graph building/querying [default = 31]")), ToolInput(tag="in_minimizer_size", input_type=Int(optional=True), prefix="--minimizer_size", doc=InputDocumentation(doc="Minimizer size to be used for k-mer hashing [default =\n23]")), ToolInput(tag="in_no_save_idx", input_type=Boolean(optional=True), prefix="--no-save-idx", doc=InputDocumentation(doc="Do not save FM-indexes for reuse")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of threads to use [default = 1]")), ToolInput(tag="in_location_bifrost_executable", input_type=String(optional=True), prefix="--bifrost", doc=InputDocumentation(doc="Location of bifrost executable [default = Bifrost]")), ToolInput(tag="in__query_presenceabsence", input_type=String(), position=0, doc=InputDocumentation(doc="--query               Query unitig presence/absence across input genomes"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Unitig_Caller_V0_1_0().translate("wdl", allow_empty_container=True)

